/*
 * @(#)$Id: aggCount.h,v 1.1 2006/05/26 03:32:11 maniatis Exp $
 *
 * Copyright (c) 2005 Intel Corporation. All rights reserved.
 *
 * This file is distributed under the terms in the attached INTEL-LICENSE file.
 * If you do not find these files, copies can be found by writing to:
 * Intel Research Berkeley, 2150 Shattuck Avenue, Suite 1300,
 * Berkeley, CA, 94704.  Attention:  Intel License Inquiry.
 * 
 * DESCRIPTION: Simple COUNT aggregate object. It counts matching
 * tuples.
 *
 */

#ifndef __AGGCOUNT_H__
#define __AGGCOUNT_H__

#include "table2.h"
#include "value.h"

class AggCount :
  public Table2::AggFunc
{
public:
  AggCount();
  
  
  virtual ~AggCount();

  
  void
  reset();
  
  
  void
  first(ValuePtr);
  

  void
  process(ValuePtr);
  
  
  ValuePtr
  result();


  static AggCount*
  mk();




private:
  /** The current count value for this aggregate */
  uint64_t _current;
};


#endif // AGGCOUNT_H
